<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPlaceItemResult_v2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfPlaceItemResult_v2 extends AbstractStructArrayBase
{
    /**
     * The PlaceItemResult_v2
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PlaceItemResult_v2[]
     */
    public $PlaceItemResult_v2;
    /**
     * Constructor method for ArrayOfPlaceItemResult_v2
     * @uses ArrayOfPlaceItemResult_v2::setPlaceItemResult_v2()
     * @param \StructType\PlaceItemResult_v2[] $placeItemResult_v2
     */
    public function __construct(array $placeItemResult_v2 = array())
    {
        $this
            ->setPlaceItemResult_v2($placeItemResult_v2);
    }
    /**
     * Get PlaceItemResult_v2 value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PlaceItemResult_v2[]|null
     */
    public function getPlaceItemResult_v2()
    {
        return isset($this->PlaceItemResult_v2) ? $this->PlaceItemResult_v2 : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPlaceItemResult_v2 method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPlaceItemResult_v2 method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePlaceItemResult_v2ForArrayConstraintsFromSetPlaceItemResult_v2(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPlaceItemResult_v2PlaceItemResult_v2Item) {
            // validation for constraint: itemType
            if (!$arrayOfPlaceItemResult_v2PlaceItemResult_v2Item instanceof \StructType\PlaceItemResult_v2) {
                $invalidValues[] = is_object($arrayOfPlaceItemResult_v2PlaceItemResult_v2Item) ? get_class($arrayOfPlaceItemResult_v2PlaceItemResult_v2Item) : sprintf('%s(%s)', gettype($arrayOfPlaceItemResult_v2PlaceItemResult_v2Item), var_export($arrayOfPlaceItemResult_v2PlaceItemResult_v2Item, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The PlaceItemResult_v2 property can only contain items of type \StructType\PlaceItemResult_v2, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PlaceItemResult_v2 value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceItemResult_v2[] $placeItemResult_v2
     * @return \ArrayType\ArrayOfPlaceItemResult_v2
     */
    public function setPlaceItemResult_v2(array $placeItemResult_v2 = array())
    {
        // validation for constraint: array
        if ('' !== ($placeItemResult_v2ArrayErrorMessage = self::validatePlaceItemResult_v2ForArrayConstraintsFromSetPlaceItemResult_v2($placeItemResult_v2))) {
            throw new \InvalidArgumentException($placeItemResult_v2ArrayErrorMessage, __LINE__);
        }
        if (is_null($placeItemResult_v2) || (is_array($placeItemResult_v2) && empty($placeItemResult_v2))) {
            unset($this->PlaceItemResult_v2);
        } else {
            $this->PlaceItemResult_v2 = $placeItemResult_v2;
        }
        return $this;
    }
    /**
     * Add item to PlaceItemResult_v2 value
     * @throws \InvalidArgumentException
     * @param \StructType\PlaceItemResult_v2 $item
     * @return \ArrayType\ArrayOfPlaceItemResult_v2
     */
    public function addToPlaceItemResult_v2(\StructType\PlaceItemResult_v2 $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PlaceItemResult_v2) {
            throw new \InvalidArgumentException(sprintf('The PlaceItemResult_v2 property can only contain items of type \StructType\PlaceItemResult_v2, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->PlaceItemResult_v2[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PlaceItemResult_v2|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PlaceItemResult_v2|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PlaceItemResult_v2|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PlaceItemResult_v2|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PlaceItemResult_v2|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PlaceItemResult_v2
     */
    public function getAttributeName()
    {
        return 'PlaceItemResult_v2';
    }
}
